#if !defined(__dlgstrm_hpp)
#define __dlgstrm_hpp

#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\dialog.h>
#include <owl\edit.h>
#include <owl\button.h>

//sockdemo include files:
#include "sockdemo.rh"

//owlsock include files:
#include "hostmgr.hpp"
#include "socksub.hpp"

class DlgSendStream : public TDialog {
public:
   enum              nState{nIdle, nWaitingForAddress, nConnecting, nConnected} myPresentState;

   TEdit*            editAddressSend;
   TEdit*            editAddressReceive;
   TEdit*            editDataSend;
   TEdit*            editDataReceive;
   TEdit*            editPort;
   TStatic*          staticStatus;
   TButton*          btnConnectDisconnect;

   StreamSocket*     myStreamSocket;
   char              szDataToSend[256];
   short             bDataSent;
   INetSocketAddress sAddressToConnectTo;
   HostInfoManager   myHostInfoManager;

   DlgSendStream(TWindow *parent, TResId resId = IDD_STREAM, TModule *module = 0);
  ~DlgSendStream();
   void SetupWindow();
   short ConnectWithThis(StreamSocket& newConnectedSocket);
   short ConnectWithThis(SOCKET& newSocket, SocketAddress& sNewAddress);
   void CmBtnSend();
   void CmBtnSendClear();
   void CmBtnReceiveClear();
   void CmConnectDisconnect();
   void CmOk();
   void Connect();
   void SendData();
   void ReadData();
   void GoToIdleState();
   void GoToWaitingForAddressState();
   void GoToConnectingState();
   void GoToConnectedState();
   LRESULT DoHostNotification(WPARAM, LPARAM lParam);
   LRESULT DoSocketNotification(WPARAM, LPARAM lParam);
   DECLARE_RESPONSE_TABLE(DlgSendStream);
};

#endif  // __dlgstrm_hpp
