//hostmgr.hpp

   /*-----------------------------------------------------------------------*\
   | OWLSock For Windows v1.0                                                |
   --------------------------------------------------------------------------|
   | Written By:  Paul Pedriana                                              |
   | Date:        May 7, 1995.                                               |
   | Copyright:   Copyright (c) 1995 by Paul Pedriana.  All Rights Reserved. |
   | UserID(s):   70541,3223                                                 |
   |              70541.3223@compuserve.com                                  |
   --------------------------------------------------------------------------|
   | OWLSock is a Winsock C++ class library for OWL and Windows (16 and 32). |
   | It makes the use of Winsock much simpler and organizes Winsock's        |
   | functionality into logical classes.  See owlsock.doc and the owlsock    |
   | source files for documentation on how to use OWLSock.                   |
   \*-----------------------------------------------------------------------*/

#ifndef _HOSTMGR_HPP
#define _HOSTMGR_HPP

#include <owl\owlpch.h>
#pragma hdrstop

#include <winsock.h>
#include <owl\window.h>
#include "address.hpp"

#define WINSOCK_NOERROR (int)0
#define WINSOCK_ERROR   (int)SOCKET_ERROR

//-********************************************************************
#define N_MAX_HOST_NAME 128  //I don't know the actual limit.  Is supposedly in RFC 883.
#define MSG_HOST_INFO_NOTIFY ((UINT)(WM_USER+303))

class HostInfoManager;

class HostInfoWindow :public TWindow{
public:
   HostInfoManager* myHostInfoManagerParent;
   HostInfoWindow(HostInfoManager* newHostInfoManagerParent);

   LRESULT DoNotification(WPARAM wParam, LPARAM lParam);
   DECLARE_RESPONSE_TABLE(HostInfoWindow);
};

//-*************************************************************************
class HostEntry : public hostent{
public:
   HostEntry();
   int GetAddressCount();
   u_long GetNthINetAddress(int nIndex = 0); //An internet addressing -specific function.
   u_long GetINetAddress(){return GetNthINetAddress(0);}
};

class HostInfoManager{
public:
   HostInfoManager();
   virtual ~HostInfoManager();

   int   GetLastError(){return nLastError;}
   int   GetHostName(char* szName, int nNameLength=N_MAX_HOST_NAME);
   int   GetHostAddress(char* szHostAddress, const char* szHostName);
   int   GetHostAddress(SocketAddress& sAddress, const char* szHostName);
   int   GetHostInfo(HostEntry*& hEntry, const SocketAddress& sAddress);
   int   GetHostInfo(HostEntry*& hEntry, const char* szName);
   int   GetHostInfoAsync(HANDLE& hTheHostRequest, SocketAddress& sAddress);
   int   GetHostInfoAsync(HANDLE& hTheHostRequest, char* szName);
   int   GetHostInfoAsync(TWindow& wndNotify, HANDLE& hTheHostRequest,
            SocketAddress& sAddress, UINT nMessage=MSG_HOST_INFO_NOTIFY, char* chBuffer=NULL);
   int   GetHostInfoAsync(TWindow& wndNotify, HANDLE& hTheHostRequest, char* szName,
            UINT nMessage=MSG_HOST_INFO_NOTIFY, char* chBuffer=NULL);
   int   CancelHostRequest(HANDLE hTheHostRequest=NULL);
   short GetHostRequestCompleted(){return bHostRequestCompleted;}
   static int HostEntryToAddress(HostEntry* hEntry, char* szAddress);
   static int HostEntryToAddress(HostEntry* hEntry, SocketAddress& sAddress);

   HostEntry*     myHostEntry;   //Set to point to chHostInfoBuffer.

protected:
   short          bHostRequestCompleted;
   HANDLE         hHostRequest;
   int            nLastError;
   char           chHostInfoBuffer[MAXGETHOSTSTRUCT];  //Used for calls to WSAAsync...()
   HostInfoWindow myWindow;
   friend class   HostInfoWindow;

   void  HostRequestCompleted(int nError);
};

#endif //_HOSTMGR_HPP




