//servmgr.hpp

   /*-----------------------------------------------------------------------*\
   | OWLSock For Windows v1.0                                                |
   --------------------------------------------------------------------------|
   | Written By:  Paul Pedriana                                              |
   | Date:        May 7, 1995.                                               |
   | Copyright:   Copyright (c) 1995 by Paul Pedriana.  All Rights Reserved. |
   | UserID(s):   70541,3223                                                 |
   |              70541.3223@compuserve.com                                  |
   --------------------------------------------------------------------------|
   | OWLSock is a Winsock C++ class library for OWL and Windows (16 and 32). |
   | It makes the use of Winsock much simpler and organizes Winsock's        |
   | functionality into logical classes.  See owlsock.doc and the owlsock    |
   | source files for documentation on how to use OWLSock.                   |
   \*-----------------------------------------------------------------------*/

#ifndef _SERVMGR_HPP
#define _SERVMGR_HPP

#include <owl\owlpch.h>
#pragma hdrstop

#include <winsock.h>
#include <owl\window.h>

#define WINSOCK_NOERROR (int)0
#define WINSOCK_ERROR   (int)SOCKET_ERROR

//-********************************************************************
#define N_MAX_SERVICE_NAME 128  //I don't know the actual limit.  Is supposedly in RFC 883.
#define MSG_SERVICE_NOTIFY ((UINT)(WM_USER+302))

class ServiceManager;

class ServiceWindow :public TWindow{
public:
   ServiceManager* myServiceManagerParent;
   ServiceWindow(ServiceManager* newServiceManagerParent);

   LRESULT DoNotification(WPARAM wParam, LPARAM lParam);
   DECLARE_RESPONSE_TABLE(ServiceWindow);
};

//-*************************************************************************
class ServiceEntry : public servent{
   ServiceEntry();
};


class ServiceManager{
public:
   ServiceManager();
   virtual ~ServiceManager();

   int   GetLastError(){return nLastError;}
   int   GetLastServiceCompletion(){return bLastServiceRequestCompleted;}
   int   GetService(ServiceEntry*& sEntry, int nPort, const char* szProtocol=NULL);
   int   GetService(ServiceEntry*& sEntry, const char* szName, const char* szProtocol=NULL);
   int   GetServicePort(char* szName, int& nPort, const char* szProtocol=NULL);
   int   GetServiceName(int nPort, char* szName, const char* szProtocol=NULL);
   int   GetServiceAsync(HANDLE& hService, int nPort, const char* szProtocol=NULL);
   int   GetServiceAsync(HANDLE& hService, char* szName, const char* szProtocol=NULL);
   int   GetServiceAsync(TWindow& wndNotify, HANDLE& hService, int nPort, const char* szProtocol=NULL,
                         UINT nMessage=MSG_SERVICE_NOTIFY, char* chBuffer=NULL);
   int   GetServiceAsync(TWindow& wndNotify, HANDLE& hService, char* szName, const char* szProtocol=NULL,
                         UINT nMessage=MSG_SERVICE_NOTIFY, char* chBuffer=NULL);
   int   CancelServiceRequest(HANDLE hService=NULL);
   short GetServiceRequestCompleted(){return bLastServiceRequestCompleted;}

   ServiceEntry*  myServiceEntry; //Set to point to chServiceBuffer.

protected:
   int            nLastError;
   int            nOutstandingServiceRequests;   //Keeps track of count of total requests done by myself that haven't completed yet.
   short          bLastServiceRequestCompleted;
   char           chServiceBuffer[MAXGETHOSTSTRUCT];  //Used for calls to WSAAsync...()
   HANDLE         hLastServiceRequest;
   ServiceWindow  myWindow;
   friend class   ServiceWindow;

   void ServiceCompleted(int nError);
};
#endif //_SERVMGR_HPP

