//sockmgr.hpp

   /*-----------------------------------------------------------------------*\
   | OWLSock For Windows v1.0                                                |
   --------------------------------------------------------------------------|
   | Written By:  Paul Pedriana                                              |
   | Date:        May 7, 1995.                                               |
   | Copyright:   Copyright (c) 1995 by Paul Pedriana.  All Rights Reserved. |
   | UserID(s):   70541,3223                                                 |
   |              70541.3223@compuserve.com                                  |
   --------------------------------------------------------------------------|
   | OWLSock is a Winsock C++ class library for OWL and Windows (16 and 32). |
   | It makes the use of Winsock much simpler and organizes Winsock's        |
   | functionality into logical classes.  See owlsock.doc and the owlsock    |
   | source files for documentation on how to use OWLSock.                   |
   \*-----------------------------------------------------------------------*/

#ifndef _SOCKMGR_HPP
#define _SOCKMGR_HPP

#include <owl\owlpch.h>
#pragma hdrstop

#include "sockets.hpp"

struct SocketInfo : public WSAData{
   SocketInfo();
};

class SocketManager{
protected:
   int          nLastError;
   short        bAvailable;
   short        nStartupCount;
   SocketInfo   mySocketInfo;
   short        nVersionMajor;
   short        nVersionMinor;

public:
   SocketManager(short nVersionMajor=1, short nVersionMinor=1, short bAutoStartup=1);
   virtual ~SocketManager();
   ISocketManager(short nNewVersionMajor=1, short nNewVersionMinor=1);

   Startup();
   ShutDown();

   int Available()                        {return bAvailable;}
   int GetMajorVersion()                  {return nVersionMajor;}
   int GetMinorVersion()                  {return nVersionMinor;}
   char* GetDescription()                 {return mySocketInfo.szDescription;}
   char* GetSystemStatus()                {return mySocketInfo.szSystemStatus;}
   unsigned short GetMaxUdpDgAvailable()  {return mySocketInfo.iMaxUdpDg;}
   unsigned short GetMaxSocketsAvailable(){return mySocketInfo.iMaxSockets;}
   char* GetVendorInfo()                  {return mySocketInfo.lpVendorInfo;}
   int GetLastError()                     {return nLastError;}
   void Information(SocketInfo& socketInfo){socketInfo = mySocketInfo;}
};

#endif //_SOCKMGR_HPP

